//FFT_Analyzer Ver.1.1    2014.2　札幌北高等学校定時制教諭　高木伸雄作成

//******** 変数等の定義 ********//
import java.awt.*;
import javax.swing.*;
import ddf.minim.analysis.*;  //Library minim使用
import ddf.minim.*;
Minim minim;
AudioInput in;  // オーディオ入力の変数
PFont font1;  //PFontオブジェクト生成
PFont font2;  //PFontオブジェクト生成
PImage img;  //PImageオブジェクト生成
FFT fft;  // FFTの変数
int samplerate;  //samplerate
int buffersize;  //buffersize
int sensitivity;  //縦軸の倍率
int frameCounter;  //ENTERキーを押したときのカウンター
int con_frameCounter;  //SPASEキーを押したときのカウンター
int framearate;  //frameRate
int keptTime;  //スペースキーを押したときのタイム
int presentTime;  //ＰＣのタイム（秒）
boolean bool_saveFrame;  //連続画像保存用、スペースキー対応
boolean bool_size;  //サイズ変更用、Ｂキー対応
boolean bool_Nkey;  //一時停止・解除用、Ｎキー対応
boolean bool_Hamming;  //Hamming窓関数On,Off、Vキー対応
boolean bool_img;  //キーボード割当説明画像表示・非表示用　Iキー対応
String savefileName; //保存ファイルの名前
String windowName;  //窓関数表示

//******** 初期化処理 ********//
void setup()
{
  framearate=30;  //frameRateの初期値を30に設定
  size(1200, 600);
  frameRate(framearate);
  samplerate = 40960;
  buffersize = 4096;  //２の累乗にしなければならない
  sensitivity = 3;
  frameCounter = 1;
  con_frameCounter =1;
  bool_saveFrame = false;
  bool_size = true;
  bool_Nkey = false;
  bool_Hamming = false;
  windowName = "None";
  savefileName = "img";
  bool_img = true;
  minim = new Minim(this);
  in = minim.getLineIn(Minim.STEREO, buffersize, samplerate);
  fft = new FFT(in.bufferSize(), samplerate);
  font1 = createFont("MS Gothic", 10, true); 
  font2 = createFont("MS Gothic", 15, true);
}

//******** 描画処理 ********//
void draw()
{
  background(0);  // 背景色を黒に設定
  fft.forward(in.mix);   // FFT 実行

  // 棒グラフの描画
  for (int i = 0; i < 301; i++)
  {
    float x = map(i, 0, 300, 0, width);
    stroke(255);  //線の色を白に設定
    strokeWeight(2);  //線の太さを２に設定
    line(x, height-35, x, height-35 - fft.getBand(i) * sensitivity * 4);
    strokeWeight(1);  //線の太さを１に設定 
    line(x, height-30, x, height-20);   //目盛り線

    //10目盛りごとに太い赤線と周波数値を入れる
    if (i%10==0) {
      strokeWeight(2);  //線の太さを２に設定
      stroke(180, 0, 0);  //赤
      line(x, height-30, x, height-20);
      textFont(font1); 
      fill(255);  //文字の色を白に設定
      text(i*10, x, height - 5);
    }
  }
  //基準の水平線を引く
  stroke(180);   // 線の色を灰色に設定
  strokeWeight(2);  //線の太さを２に設定
  line(0, height-35, width, height-35);  

  textFont(font1);
  fill(255);
  text("Hz", width-15, height-5);
  textFont(font2);
  fill(255);
  text("sensitivity " + sensitivity, 165, 20);  //画面にsensitivity表示
  text("frameRate " + framearate + "/sec", 15, 20);  //画面にframeRate表示
  text("window function " + windowName, 290, 20);  //画面に窓関数表示

  //10秒経過測定、画像保存実行 
  presentTime = second();
  if (bool_saveFrame == true) {
    saveFrame("c_" + savefileName + con_frameCounter + ".tif"); 
    con_frameCounter = con_frameCounter + 1;
      if (presentTime - keptTime == 10 || presentTime - keptTime + 60 == 10) {
        bool_saveFrame = false;
      }
    noStroke();  
    fill(255, 0, 0);
    ellipse(550, 15, 12, 12);  //画面に赤丸表示
  }
  
  //キーボード割当説明画像表示
  if(bool_img == true){
    img = loadImage("data/img.jpg");
    image(img,15,15,width-30,height-25 );
    noLoop();
  }
}

//******** キーに機能割り当て ********//
void keyPressed() 
{
  //ENTERキーを押したときの処理
  if (key == ENTER && bool_img == false) { 
    save(savefileName + frameCounter + ".tif");
    frameCounter = frameCounter + 1;
  }
  //SPASEキーを押したときの処理    
  if (key == ' ' && bool_Nkey == false && bool_img == false) {
    if (bool_saveFrame == false) {
      bool_saveFrame = true;
      keptTime = presentTime;
    }
    else if (bool_saveFrame ==true) {
      bool_saveFrame = false;
    }
  }
  //矢印キーを押したときの処理   
  if (key == CODED && bool_img == false) {	
    if (keyCode == UP) {
      if (sensitivity < 5) {
        sensitivity = sensitivity + 1 ;
      }
    } 
    else if (keyCode == DOWN) {
      if (sensitivity > 1) { 
        sensitivity = sensitivity - 1;
      }
    }
    else if (keyCode == RIGHT) {
      if (framearate < 60) {
        framearate = framearate + 10 ;
        frameRate(framearate);
      }
    } 
    else if (keyCode == LEFT) {
      if (framearate > 10) { 
        framearate = framearate - 10;
        frameRate(framearate);
      }
    }
  }
  // Sキーを押したときの処理 （ Stop、FFT停止）    
  if (key == 's' && bool_img == false|| key == 'S' && bool_img == false) {
    if(bool_Nkey == false){
      noLoop();
      bool_saveFrame = false;
      bool_Nkey = true;
      textFont(font2); 
      fill(255, 255, 0);    
      text("Stop", 500, 20); 
      //赤丸を黒く塗る
      noStroke();  
      fill(0, 0, 0);
      ellipse(550, 15, 12, 12);
    }
    else if(bool_Nkey == true){
      bool_Nkey = false;
      loop();      
    }
  }
  //Fキーを押したときの処理 （サイズ変更）
  if (key == 'f'|| key == 'F') {  
    if (bool_size == true && bool_Nkey ==false) {
      bool_size = false;
      size(840, 420); 
      frame.setSize(846, 452);
        if(bool_img == true){
          loop();  
        }
    }
    else if (bool_size == false && bool_Nkey ==false) {
      bool_size = true;
      size(1200, 600); 
      frame.setSize(1206, 632);
       if(bool_img == true){
        loop();        
      }
    }
  }
  //Hキーを押したときの処理（Hamming窓関数On/Off）  
  if(key == 'h' && bool_img == false || key == 'H' && bool_img == false){
    if(bool_Hamming == false){
      bool_Hamming = true; 
      fft.window(FFT.HAMMING);
      windowName = "Hamming";
    }
    else if(bool_Hamming == true){
      bool_Hamming = false;
      fft.window(FFT.NONE);
      windowName = "None";
    }
  }  
  //Iキーを押したときの処理 （ キーボード割当説明画像表示・非表示）
   if(key == 'I' || key == 'i'){
     if(bool_img == true){
       bool_img = false;
       loop();
     }
     else if(bool_img == false){
       bool_img = true;
     }
   }
  //Tキーを押したときの処理  （ 保存画像名入力テキストボックス表示）
   if(key == 'T' || key == 't'){
     noLoop();
    JPanel panel = new JPanel();
    BoxLayout layout = new BoxLayout(panel, BoxLayout.Y_AXIS);
    panel.setLayout(layout);
    panel.add(new JLabel("保存画像名入力"));
    JTextField text1 = new JTextField();
    panel.add(text1);

    int r = JOptionPane.showConfirmDialog(
        null,	 // オーナーウィンドウ
        panel,	 // メッセージ
        "",	 // ウィンドウタイトル
        JOptionPane.OK_CANCEL_OPTION,	// オプション（ボタンの種類）
        JOptionPane.PLAIN_MESSAGE);	// メッセージタイプ（アイコンの種類）
      if( r == 0){
         savefileName = text1.getText(); 
         frameCounter = 1;
         con_frameCounter = 1;
         loop();
      }
      else if( r == 2){
         loop();
      }
   }
}

//******** プログラム終了時の処理 ********//
  void stop()
{
  minim.stop();
  super.stop();
}

